from django.db import models
from reqman.apps.account.models import User

from pygments.formatters.html import HtmlFormatter
from pygments import highlight

from reqman.apps.reqtool.rest_api.services.parse_ontologies import *


find_subclass_domain_range()
#MAIN SYNTAX
#import pprint
#pprint.pprint(get_main_sytax())

MAIN_CHOICES = ( ("",""),   ("M1", "M1"), 
                            ("M2", "M2"), 
                            ("M3", "M3"),
                            ("M4", "M4"),
                            ("M5", "M5"),
                            ("M6", "M6"),
                            ("M7", "M7"),
                            ("M8", "M8"),
                            ("M9", "M9"),
                            ("M10", "M10"),
                            ("M11", "M11"),
                            ("M12", "M12"),
                            ("M13", "M13"),
                            ("M14", "M14"),
                            ("M15", "M15"),
                            ("M16", "M16"),
                        )


#to be updated with domains from DSO
SYSTEM_CHOICES = get_instances("SAO#System") #+get_i_instances("SAO#System")
#print(get_instances("SAO#System"))
FUNCTION_CHOICES = get_instances("SAO#Function")
SHALL_CHOICES = ( ("shall", "shall"), ("shall not", "shall not"))
QUANTIFIER_CHOICES = ( ("none","NONE"), ("all", "ALL"), ("only", "ONLY"),
                                ("more than", "MORE THAN"), ("less than", "LESS THAN"), ("exactly","EXACTLY"), 
                                ("at least", "AT LEAST"), ("at most", "AT MOST")
                     )
NUMBER_UNITS_CHOICES = (("",""), ("meters","METERS"), ("kilometers","KILOMETERS"), ("volt","VOLT"))
ITEM_CHOICES = get_instances("SAO#Item")
#NO ITEM returned
STATE_VALUE_CHOICES =get_instances("SAO#StateValue")
#print(STATE_VALUE_CHOICES)
STATE_CHOICES = get_instances("SAO#State")
#nothing return get_instances
STATE_SET_CHOICES = get_i_instances("SAO#StateSet")
#print(STATE_SET_CHOICES)
FLOW_CHOICES = get_instances("SAO#Flow")
INTERFACE_CHOICES = get_instances("SAO#Interface")
CONNECTION_CHOICES = get_instances("SAO#Connection")
#add automatic function ot get verbs
VERB_CHOICES = (("set","set"),("send","send"),("receive","receive"),("ingest","ingest"),("emit","emit"),("perform","perform"),("invoke","invoke"),
                ("present","present"),("transfer","transfer"),("interact with","interact with"),("have state","have state"),("have substate","have substate"),
                ("take values from","take values from"),("be composed","be composed"),("contain","contain"))

#test to add M
CLASS_CHOICES = (("SYSTEM","SYSTEM"), ("FUNCTION","FUNCTION"), ("SHALL","SHALL/SHALL NOT"),
                ("QUANTIFIER","QUANTIFIER"), ("NUMBER_UNITS","NUMBER_UNITS"), ("ITEM","ITEM"),
                ("STATE_VALUE","STATE_VALUE"), ("STATE","STATE"), ("STATE_SET","STATE_SET"),
                ("FLOW","FLOW"), ("INTERFACE","INTERFACE"), ("CONNECTION","CONNECTION"), ("VERB","VERB") )

def create_main(instance):
    '''Create the Main Model for the Boilerplate'''
    try :
        main = Main.objects.get(boilerplate_of_main = instance, main_owner = instance.owner)
        if instance.has_main:
            return
        main = Main.objects.get(boilerplate_of_main = instance, main_owner = instance.owner)
        main.delete()
    except Main.DoesNotExist:
        if instance.has_main:
            main = Main(boilerplate_of_main = instance, main_owner = instance.owner)
            main.save()


class Main(models.Model):
    boilerplate_of_main = models.ForeignKey('reqtool.Boilerplate', related_name='main_boilerplate', on_delete=models.CASCADE)
    main_owner = models.ForeignKey(User, related_name='main_owner', on_delete=models.CASCADE)
    #Subject
    sys_fun_inter = models.CharField(choices=SYSTEM_CHOICES + FUNCTION_CHOICES + INTERFACE_CHOICES, max_length=100)
    #Between Subject - Verb
    state_item_before_verb = models.CharField(choices=STATE_CHOICES + ITEM_CHOICES, max_length=100, blank=True)
    statevalue_before_verb = models.CharField(choices=STATE_VALUE_CHOICES, max_length=100, blank=True)
    #Verb
    shall = models.CharField(choices=SHALL_CHOICES, max_length=100)
    verb = models.CharField(choices=VERB_CHOICES, max_length=100)
    #Between Verb - Object
    quantifier = models.CharField(choices=QUANTIFIER_CHOICES, max_length=100, blank=True)
    numerical = models.IntegerField(blank=True, null=True) 
    mumerical_units = models.CharField(choices=NUMBER_UNITS_CHOICES, max_length=100, blank=True)
    #Οbject
    flow_function_interface_item_system_state_stateset = models.CharField(choices=FLOW_CHOICES + FUNCTION_CHOICES + INTERFACE_CHOICES + ITEM_CHOICES + SYSTEM_CHOICES +STATE_CHOICES + STATE_SET_CHOICES, max_length=100)
    #last definitions
    statevalue_system_connection_stateset = models.CharField(choices=STATE_VALUE_CHOICES + SYSTEM_CHOICES + CONNECTION_CHOICES + STATE_SET_CHOICES, max_length=100, blank=True)
    #ID [M1-M16]
    main_choices = models.CharField(choices=MAIN_CHOICES, max_length=100)

    class Meta:
        ordering = ['boilerplate_of_main']

